﻿using System;
using System.Collections.Generic;
using System.Text.RegularExpressions;
using System.Windows.Input;
using System.Windows.Forms;
using System.Drawing;
using Microsoft.VisualStudio.TestTools.UITesting;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Microsoft.VisualStudio.TestTools.UITest.Extension;
using Keyboard = Microsoft.VisualStudio.TestTools.UITesting.Keyboard;
using System.IO;


namespace Benday.CodedUi.Tests
{
    /// <summary>
    /// Summary description for CodedUITest1
    /// </summary>
    [CodedUITest]
    public class ApplicationUnderTestAndBrowserWindowFixture
    {
        public ApplicationUnderTestAndBrowserWindowFixture()
        {
        }

        [TestMethod]
        public void RunTestAgainstWindowsApplication()
        {
            LaunchTheWindowsApp();

            this.UIMap.AssertInitialMessageValue();

            this.UIMap.ClickHelloWorldButton();
            this.UIMap.AssertMessageSaysHelloWorld();
        }

        [TestMethod]
        public void RunTestAgainstWebApplication()
        {
            LaunchTheWebApp();

            this.UIMap.AssertSearchBoxIsEmpty();
            this.UIMap.SearchForBenjaminDayConsulting();
        }

        private void LaunchTheWebApp()
        {
            var url = Environment.GetEnvironmentVariable(
                "Benday-CodedUi-Sample-PathToWebSite");

            Assert.IsFalse(
                String.IsNullOrWhiteSpace(url),
                "Url value is empty.  The value is '{0}'.  Hint: " +
                "try rebuilding the solution, then close Visual Studio, " +
                "and then reload this solution.",
                url);

            BrowserWindow.Launch(new Uri(url));
        }

        private void LaunchTheWindowsApp()
        {
            var pathToExe = Environment.GetEnvironmentVariable(
                "Benday-CodedUi-Sample-PathToHelloWorld");

            Assert.IsTrue(
                File.Exists(pathToExe),
                "Path to exe value does not point to a file that exists.  " +
                "The value is '{0}'.  Hint: try rebuilding the WPF app, " +
                " then close Visual Studio, and then reload this solution.",
                pathToExe);

            ApplicationUnderTest.Launch(pathToExe);
        }

        #region Additional test attributes

        // You can use the following additional attributes as you write your tests:

        ////Use TestInitialize to run code before running each test 
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{        
        //    // To generate code for this test, select "Generate Code for Coded UI Test" from the shortcut menu and select one of the menu items.
        //    // For more information on generated code, see http://go.microsoft.com/fwlink/?LinkId=179463
        //}

        ////Use TestCleanup to run code after each test has run
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{        
        //    // To generate code for this test, select "Generate Code for Coded UI Test" from the shortcut menu and select one of the menu items.
        //    // For more information on generated code, see http://go.microsoft.com/fwlink/?LinkId=179463
        //}

        #endregion

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }
        private TestContext testContextInstance;

        public UIMap UIMap
        {
            get
            {
                if ((this.map == null))
                {
                    this.map = new UIMap();
                }

                return this.map;
            }
        }

        private UIMap map;
    }
}
